Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa31s.bas                                                               *
'*                                                                           *
'* aISA-P31                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szTitle = "Sample"
Private Const szP31 = "aISA-P31"

Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim InValue As Byte
    Dim OutValue As Byte
    Dim ri As AISA31RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa31.dll ̎gp錾
    If Aisa31wDllOpen() = False Then
        ErrorMessage (AISA31_SLOT_AUTO)
        Exit Sub                ' aisa31.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa31wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-P31DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA31_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P31̎gp錾
    wLogSlot = AISA31_SLOT_AUTO     ' gp̃foCXT܂B

    ' ꍇA̎̃foCXi[܂B
    bResult = Aisa31wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA31_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-P31 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa31wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szP31 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 1 ɔCӂ̃f[^o
    ' &HAA -> 10101010
    OutValue = &HAA

    If Aisa31wOutPort(wLogSlot, AISA31_PORT_1, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 1 փf[^o" + Chr(10) + _
             "Port 1 Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 1 f[^ǂݍ
    InValue = &H0

    If Aisa31wInPort(wLogSlot, AISA31_PORT_1, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 1 f[^" + Chr(10) + _
             "Port 1 In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P31̎gpJ
    If Aisa31wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-P31 Closed")

'---------------------------------------------------------------------------
    ' aisa31.dll ̎gpJ
    If Aisa31wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa31.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Integer
    Dim szbuf As String

    dwRes = Aisa31wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA31_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA31_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else
        szbuf = "aISA-P31 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
